<template>
  <div class="position">
    <b-container>
      <b-card>
          <b-card
            title="การตั้งค่าโปรไฟล์บริษัท"
            body-class="text-center"
            header-tag="nav"
            bg-variant="light"
            class="card"
            style="width: 1109px; margin-left:-20px"
          >
          </b-card>
        <b-card-body ref="b-form-group" @submit.stop.prevent="handleSubmit">
          <b-card-text>
            <b-row>
              <b-col>
                <div class="border">
              <b-row>
              <b-col style="margin-left: -10px;">
                <b-form-group label-for="form-username"
                  label="ชื่อผู้ใช้งาน: "
                  label-align-sm="right"
                  label-cols-sm="3"
                  :valid-feedback="validFeedbackUsername"
                  :invalid-feedback="invalidFeedbackUsername"
                  :state="stateUsername"
                  style="margin-top:20px"
                >
                <b-form-input
                id="username"
                size="md"
                placeholder="ชื่อผู้ใช้งาน"
                v-model="currentCompany.username"
                required
                disabled
                >
                </b-form-input>
                </b-form-group>
              </b-col>
            </b-row>

            <b-row>
              <b-col style="margin-left: -10px;">
                <b-form-group
                id="email"
                label="Email: "
                label-align-sm="right"
                label-cols-sm="3"
                :valid-feedback="validFeedbackEmail"
                :invalid-feedback="invalidFeedbackEmail"
                :state="stateEmail"
                >
                <b-form-input
                type="text"
                id="email"
                placeholder="Email"
                v-model="currentCompany.email"
                required
                disabled
                ></b-form-input>
                </b-form-group>
              </b-col>
            </b-row>
              </div><br>
              </b-col><br>

              <b-col sm="6">
                <div class="Image">
                  <b-card>
                  <b-card-img
                    class="ImagePerson"
                    src="https://www.nicepng.com/png/full/192-1921815_-corgi-cartoon-face.png" style="width:90px; height: 100px;"
                  ></b-card-img>
                  </b-card>
                </div><br>
                <div class="btnImage">
                  <button class="btn btn-info image" style="width: 60%">อัพโหลดรูปภาพ</button>
                </div><br>
              </b-col>
            </b-row>

            <b-row class="my-1">
              <b-col sm="6">
                <b-form-group
                id="companyName"
                label="ชื่อบริษัท: "
                label-align-sm="right"
                label-cols-sm="3"
                :valid-feedback="validFeedbackCompanyName"
                :invalid-feedback="invalidFeedbackCompanyName"
                :state="stateCompanyName"
                >
                <b-form-input
                type="text"
                id="companyName"
                placeholder="ชื่อบริษัท"
                v-model="currentCompany.companyName"
                required
                disabled
                ></b-form-input>
                </b-form-group>

                <b-form-group
                id="detai"
                label="ลักษณะธุรกิจ: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-detail"
                :valid-feedback="validFeedbackDetail"
                :invalid-feedback="invalidFeedbackDetail"
                :state="stateDetail"
                >
                <b-form-select v-model="currentCompany.styleBusiness" :options="detail" size="md" id="detail" required>
                <b-form-select-option :value="currentCompany.styleBusiness" disabled>{{ currentCompany.styleBusiness }}</b-form-select-option>
                </b-form-select>
                </b-form-group>
              </b-col>
              <b-col sm="6">
                <b-form-group id="lbaddress" label="บ้านเลขที่: " label-align-sm="right" label-cols-sm="3"
                  label-for="form-address"
                  :valid-feedback="validFeedbackAddress"
                  :invalid-feedback="invalidFeedbackAddress"
                  :state="stateAddress"
                >
                  <b-form-input id="address" size="" placeholder="บ้านเลขที่" v-model="currentCompany.addressCompany.number" required></b-form-input>
                </b-form-group>

                <b-form-group
                id="villageNo"
                label="หมู่: "
                label-align-sm="right"
                label-cols-sm="3"
                >
                <b-form-input
                type="text"
                id="villageNo"
                placeholder="หมู่"
                v-model="currentCompany.addressCompany.villageNo"
                required
                ></b-form-input>
                </b-form-group>
              </b-col>
            </b-row>

            <b-row class="my-1">
              <b-col sm="6">
                <b-form-group
                id="security"
                label="สวัสดิการ: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-security"
                :valid-feedback="validFeedbackSecurity"
                :invalid-feedback="invalidFeedbackSecurity"
                :state="stateSecurity"
                >
                <b-form-textarea
                type="text"
                id="security"
                placeholder="สวัสดิการ"
                v-model="currentCompany.security"
                required
                ></b-form-textarea>
                </b-form-group>

                <b-form-group
                id="registation"
                label="ทะเบียนบริษัท: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-registation"
                :valid-feedback="validFeedbackRegistation"
                :invalid-feedback="invalidFeedbackRegistation"
                :state="stateRegistation"
                >
                <b-form-input
                type="text"
                id="registation"
                placeholder="ทะเบียนบริษัท"
                v-model="currentCompany.companyCode"
                required
                disabled
                ></b-form-input>
                </b-form-group>
              </b-col>

              <b-col>
                <b-form-group
                id="province"
                label="จังหวัด: "
                label-align-sm="right"
                label-cols-sm="3"
                :valid-feedback="validFeedbackProvince"
                :invalid-feedback="invalidFeedbackProvince"
                :state="stateProvince"
                >
                <b-form-select v-model="currentCompany.addressCompany.province" :options="province" size="md" id="province" required>
                <b-form-select-option :value="currentCompany.addressCompany.province" disabled>{{ currentCompany.addressCompany.province }}</b-form-select-option>
                </b-form-select>
                </b-form-group>

                <b-form-group
                id="district"
                label="เขต/อำเภอ: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-district"
                :valid-feedback="validFeedbackDistrict"
                :invalid-feedback="invalidFeedbackDistrict"
                :state="stateDistrict"
                >
                <b-form-select v-model="currentCompany.addressCompany.district" :options="district" size="md" id="district" required>
                <b-form-select-option :value="currentCompany.addressCompany.district" disabled>{{ currentCompany.addressCompany.district }}</b-form-select-option>
                </b-form-select>
                </b-form-group>
              </b-col>
            </b-row>

            <b-row class="my-1">
              <b-col sm="6">
                <b-form-group
                id="contactName"
                label="ชื่อผู้ติดต่อ: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-contactName"
                :valid-feedback="validFeedbackContactName"
                :invalid-feedback="invalidFeedbackContactName"
                :state="stateContactName"
                >
                <b-form-input
                type="text"
                id="contactName"
                placeholder="ชื่อผู้ติดต่อ"
                v-model="currentCompany.contactName"
                required
                ></b-form-input>
                </b-form-group>
              </b-col>
              <b-col>
                <b-form-group
                id="subdistrict"
                label="แขวง/ตำบล: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-subdistrict"
                :valid-feedback="validFeedbackSubdistrict"
                :invalid-feedback="invalidFeedbackSubdistrict"
                :state="stateSubdistrict"
                >
                <b-form-select v-model="currentCompany.addressCompany.subDistrict" :options="subdistrict" size="md" id="subdistrict" required>
                <b-form-select-option :value="currentCompany.addressCompany.subDistrict" disabled>{{ currentCompany.addressCompany.subDistrict }}</b-form-select-option>
                </b-form-select>
                </b-form-group>
              </b-col>
            </b-row>

            <b-row class="my-1">
              <b-col sm="6">

              </b-col>

              <b-col>
              </b-col>
            </b-row>

            <b-row class="my-1">
              <b-col sm="6">
                <b-form-group
                id="description"
                label="รายละเอียดธุรกิจ: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-description"
                :valid-feedback="validFeedbackDescription"
                :invalid-feedback="invalidFeedbackDescription"
                :state="stateDescription"
                >
                <b-form-textarea
                type="text"
                id="description"
                placeholder="รายละเอียดธุรกิจ"
                v-model="currentCompany.detailCompany"
                required
                ></b-form-textarea>
                </b-form-group>
              </b-col>

              <b-col>
                <b-form-group
                id="zipcode"
                label="รหัสไปรษณีย์: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-zipcode"
                :valid-feedback="validFeedbackZipcode"
                :invalid-feedback="invalidFeedbackZipcode"
                :state="stateZipcode"
                >
                <b-form-select v-model="currentCompany.addressCompany.postalCode" :options="zipcode" size="md" id="zipcode" required>
                <b-form-select-option :value="currentCompany.addressCompany.postalCode" disabled>{{ currentCompany.addressCompany.postalCode }}</b-form-select-option>
                </b-form-select>
                </b-form-group>
              </b-col>
            </b-row>

            <b-row class="my-1">
              <b-col sm="6">
                <b-form-group
                id="tel"
                label="เบอร์โทรศัพท์: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-tel"
                :valid-feedback="validFeedbackTel"
                :invalid-feedback="invalidFeedbackTel"
                :state="stateTel"
                >
                <b-form-input
                type="text"
                id="tel"
                placeholder="เบอร์โทรศัพท์ "
                v-model="currentCompany.telCompany"
                required
                ></b-form-input>
                </b-form-group>
              </b-col>

              <b-col>
                <b-form-group
                id="website"
                label="Website: "
                label-align-sm="right"
                label-cols-sm="3"
                >
                <b-form-input
                type="text"
                id="website"
                placeholder="Website"
                v-model="currentCompany.website"
                ></b-form-input>
                </b-form-group>
              </b-col>
            </b-row>

            <b-row class="my-1">
              <b-col sm="6">
              </b-col>

              <b-col>
                <b-form-group
                id="facebook"
                label="Facebook: "
                label-align-sm="right"
                label-cols-sm="3"
                >
                <b-form-input
                type="text"
                id="facebook"
                placeholder="Facebook"
                v-model="currentCompany.facebook"
                ></b-form-input>
                </b-form-group>
              </b-col>
            </b-row>

            <b-row>
              <b-col>
              </b-col>
              <b-col>
                <div>
                <b-col class="btn">
                <b-button v-b-modal.modal-form-Company class="btn-success" @click="updateCompany()" >ยืนยัน</b-button>
                <b-modal id="modal-form-Company" title="ยืนยันการบันทึกข้อมูล" okTitle="ตกลง" ok-variant="success" cancel-title="ยกเลิก" cancel-variant="danger" class="alert"
                  v-b-modal.modal-addNewCompany
                  ref="modal-form-Company"
                >
                <p style="display: flex; justify-content: center;">บันทึกข้อมูลเรียบร้อย</p>
              </b-modal>
                <b-button id="can" class="cancle btn btn-danger" @submit.stop.prevent="handleSubmit">ยกเลิก</b-button>
                <br>
                <div class="btncancle">
                <b-button block variant="danger">ยกเลิกการเป็นสมาชิก</b-button>
              </div>
              </b-col>
              </div>
              </b-col>
            </b-row>
          </b-card-text>
        </b-card-body>
      </b-card>
    </b-container>
  </div>
</template>

<script>
import companyService from '../Service/company'
export default {
  data () {
    return {
      currentCompany: [],
      selected: null,
      province: [
        { value: 'A', text: 'ชลบุรี' },
        { value: 'B', text: 'กรุงเทพมหานคร' },
        { value: 'C', text: 'พระนครศรีอยุธยา' },
        { value: 'D', text: 'ระยอง' }
      ],
      detail: [
        { value: 'A', text: 'ธุรกิจการกระดาษ/เครื่องเขียน' },
        { value: 'B', text: 'ธุรกิจการเกษตร' },
        { value: 'C', text: 'ธุรกิจการพิมพ์/สิ่งพิมพ์' },
        { value: 'D', text: 'ธุรกิจเพื่อการศึกษา' },
        { value: 'E', text: 'ธุรกิจขนส่ง' },
        { value: 'F', text: 'ธุรกิจคอมพิวเตอร์/IT' }
      ],
      district: [
        { value: 'A', text: 'อำเภอเมือง' },
        { value: 'A', text: 'อำเภอแสนสุข' },
        { value: 'A', text: 'อำเภอบ้านบึง' },
        { value: 'A', text: 'อำเภอศรีราชา' },
        { value: 'A', text: 'อำเภอหนองใหญ่' },
        { value: 'A', text: 'อำเภอพนัสนิคม' }
      ],
      subdistrict: [
        { value: 'A', text: 'ตำบลบางปลาสร้อย' },
        { value: 'A', text: 'ตำบลคลองตำหรุ' },
        { value: 'A', text: 'ตำบลบางทราย' },
        { value: 'A', text: 'ตำบลสำนักบก' },
        { value: 'A', text: 'ตำบลบ้านสวน' },
        { value: 'A', text: 'ตำบลบ้านบึง' }
      ],
      zipcode: [
        { value: 'A', text: '20000' },
        { value: 'A', text: '20170' },
        { value: 'A', text: '20130' },
        { value: 'A', text: '20110' },
        { value: 'A', text: '20160' },
        { value: 'A', text: '20240' }
      ],
      form: {
        id: -1,
        username: '',
        img: '',
        password: '',
        address: '',
        repassword: '',
        province: '',
        email: '',
        district: '',
        companyName: '',
        subdistrict: '',
        description: '',
        zipCode: '',
        security: '',
        website: '',
        contactName: '',
        facebook: '',
        registation: '',
        detail: '',
        tel: ''
      }
    }
  },
  methods: {
    updateCompany () {
      console.log('updatecompany')
      this.$bvModal.show('modal-form-Company')
      var company = companyService.getcompany(1)
      this.currentCompany = companyService.updateCompany(company)
      // companyService.updateCompany(this.form)
      console.log(companyService.lastId)
      console.log(this.currentCompany)
      this.resetModal()
    },
    resetModal () {
      this.form = {
        id: -1,
        username: '',
        password: '',
        repassword: '',
        email: '',
        companyName: '',
        description: '',
        img: '',
        address: '',
        province: '',
        district: '',
        security: '',
        subdistrict: '',
        registation: '',
        contactName: '',
        detail: '',
        zipCode: '',
        tel: '',
        website: '',
        facebook: ''
      }
    },
    getCompany () {
      // this.currentCompany = companyService.currentCompany[0]
      this.currentCompany = companyService.getcompany(1)
    },
    handleOk (bvModalEvt) {
      // Prevent modal from closing
      bvModalEvt.preventDefault()
      // Trigger submit handler
      this.handleSubmit()
    },
    handleSubmit () {
      this.updateCompany()
    }
  },
  computed: {
    stateUsername () {
      return this.form.username.length >= 10 && this.form.user.length <= 16
    },
    invalidFeedbackUsername () {
      if (this.form.username.length >= 10) {
        return 'กรุณากรอกชื่อผู้ใช้งาน 10-16 ตัวอักษร'
      } else if (this.form.username.length > 0) {
        return 'กรุณากรอกชื่อผู้ใช้งานอย่างน้อย 10 ตัวอักษร'
      } else {
        return 'กรุณากรอกชื่อผู้ใช้งาน'
      }
    },
    validFeedbackUsername () {
      return this.stateUsername === true ? 'สำเร็จ' : ''
    },
    statePassword () {
      return this.form.password.length >= 8 && this.form.password.length <= 16
    },
    invalidFeedbackPassword () {
      if (this.form.password.length > 8) {
        return ''
      } else if (this.form.password.length > 8 && this.form.password.length <= 16) {
        return 'กรุณากรอกรหัสผ่านงานอย่างน้อย 8 ตัวอักษร แต่น้อยกว่า 16 ตัวอักษร'
      } else {
        return 'กรุณากรอกรหัสผ่าน'
      }
    },
    validFeedbackPassword () {
      return this.statePassword === true ? 'สำเร็จ' : ''
    },
    stateRepassword () {
      return this.form.repassword === this.form.password &&
      this.form.repassword.length >= 8 && this.form.repassword.length <= 16
    },
    invalidFeedbackRepassword () {
      if (this.form.repassword !== this.form.password) {
        return 'กรุณากรอกรหัสผ่านให้ตรงกัน'
      } else if (this.form.repassword !== null) {
        return 'กรุณากรอกรหัสผ่านยืนยันรหัสผ่าน'
      } else {
        return 'กรุณากรอกรหัสผ่านยืนยันรหัสผ่าน'
      }
    },
    validFeedbackRepassword () {
      return this.stateRepassword === true ? 'สำเร็จ' : ''
    },
    stateAddress () {
      return this.form.address !== ''
    },
    invalidFeedbackAddress () {
      if (this.form.address === '') {
        return 'กรุณกรอกบ้านเลขที่'
      } else {
        return 'กรุณากรอกบ้านเลขที่'
      }
    },
    validFeedbackAddress () {
      return this.stateAddress === true ? 'สำเร็จ' : ''
    },
    stateEmail () {
      return /^\w+([\\.-]?\w+)@\w+([\\.-]?\w+)(.\w{2,3})+$/.test(
        this.form.email
      )
    },
    invalidFeedbackEmail () {
      if (this.form.email.length === 0) {
        return 'กรุณากรอกอีเมล'
      } else if (this.form.email !== /^\w+([\\.-]?\w+)@\w+([\\.-]?\w+)(.\w{2,3})+$/) {
        return 'กรุณากรอกอีเมลให้ถูกต้อง'
      } else {
        return ''
      }
    },
    validFeedbackEmail () {
      return this.stateEmail === true ? 'สำเร็จ' : ''
    },
    stateCompanyName () {
      return this.form.companyName.length >= 3
    },
    invalidFeedbackCompanyName () {
      if (this.form.companyName.length > 2) {
        return ''
      } else if (this.form.companyName.length > 0) {
        return 'กรุณากรอกตัวอักษรอย่างน้อย 3 ตัวอักษร.'
      }
      return 'กรุณากรอกชื่อบริษัท'
    },
    validFeedbackCompanyName () {
      return this.stateCompanyName === true ? 'สำเร็จ' : ''
    },
    stateProvince () {
      return this.form.province.length === 1
    },
    invalidFeedbackProvince () {
      if (this.form.province.length > 0) {
        return 'กรุณากรอกจังหวัด มากกว่า 2 ตัวอักษร'
      } else {
        return 'กรุณากรอกจังหวัด'
      }
    },
    validFeedbackProvince () {
      return this.stateProvince === true ? 'สำเร็จ' : ''
    },
    stateDetail () {
      return this.form.detail.length === 1
    },
    invalidFeedbackDetail () {
      if (this.form.detail.length > 0) {
        return 'กรุณากรอกลักษณะธุรกิจ มากกว่า 2 ตัวอักษร'
      } else {
        return 'กรุณากรอกลักษณะธุรกิจ'
      }
    },
    validFeedbackDetail () {
      return this.stateDetail === true ? 'สำเร็จ' : ''
    },
    stateSecurity () {
      return this.form.security.length >= 20
    },
    invalidFeedbackSecurity () {
      if (this.form.security.length > 0) {
        return 'กรุณากรอกสวัสดิการ มากกว่า 20 ตัวอักษร'
      } else {
        return 'กรุณากรอกสวัสดิการ'
      }
    },
    validFeedbackSecurity () {
      return this.stateSecurity === true ? 'สำเร็จ' : ''
    },
    stateRegistation () {
      return this.form.registation.length === 12
    },
    invalidFeedbackRegistation () {
      if (this.form.registation.length > 12) {
        return ''
      } else if (this.form.registation.length > 0) {
        return 'ต้องกรอกทะเบียนบริษัท 12 ตัวอักษร'
      } else {
        return 'กรุณากรอกทะเบียนบริษัท'
      }
    },
    validFeedbackRegistation () {
      return this.stateRegistation === true ? 'สำเร็จ' : ''
    },
    stateContactName () {
      return this.form.contactName.length >= 3
    },
    invalidFeedbackContactName () {
      if (this.form.contactName.length > 2) {
        return ''
      } else if (this.form.contactName.length > 0) {
        return 'ต้องมีชื่อผู้ติดต่ออย่างน้อย 2 ตัวอักษร'
      } else {
        return 'กรุณากรอกชื่อผู้ติดต่อ'
      }
    },
    validFeedbackContactName () {
      return this.stateContactName === true ? 'สำเร็จ' : ''
    },
    stateDescription () {
      return this.form.description.length >= 20
    },
    invalidFeedbackDescription () {
      if (this.form.description.length > 0) {
        return 'กรุณกรอกรายละเอียดธุรกิจ มากกว่า 20 ตัวอักษร'
      } else {
        return 'กรุณากรอกรายละเอียดธุรกิจ'
      }
    },
    validFeedbackDescription () {
      return this.stateDescription === true ? 'สำเร็จ' : ''
    },
    stateTel () {
      return this.form.tel.length === 10
    },
    invalidFeedbackTel () {
      if (this.form.tel.length > 0) {
        return 'กรุณากรอกตัวเลข 10 ตัวอักษร'
      } else if (this.form.tel.length > 0) {
        return 'กรุณากรอกตัวเลข 10 ตัวอักษร'
      }
      return 'กรุณากรอกเบอร์โทรศัพท์'
    },
    validFeedbackTel () {
      return this.stateTel === true ? 'สำเร็จ' : ''
    },
    stateDistrict () {
      return this.form.district.length === 1
    },
    invalidFeedbackDistrict () {
      if (this.form.district.length > 0) {
        return 'กรุณากรอกอำเภอ มากกว่า 2 ตัวอักษร'
      } else {
        return 'กรุณากรอกอำเภอ'
      }
    },
    validFeedbackDistrict () {
      return this.stateDistrict === true ? 'สำเร็จ' : ''
    },
    stateSubdistrict () {
      return this.form.subdistrict.length === 1
    },
    invalidFeedbackSubdistrict () {
      if (this.form.subdistrict.length > 0) {
        return 'กรุณากรอกตำบล มากกว่า 2 ตัวอักษร'
      } else {
        return 'กรุณากรอกตำบล'
      }
    },
    validFeedbackSubdistrict () {
      return this.stateSubdistrict === true ? 'สำเร็จ' : ''
    },
    stateZipcode () {
      return this.form.zipCode.length === 1
    },
    invalidFeedbackZipcode () {
      if (this.form.zipCode.length > 0) {
        return 'กรุณรหัสไปรษณีย์ มากกว่า 2 ตัวอักษร'
      } else {
        return 'กรุณากรอกรหัสไปรษณีย์'
      }
    },
    validFeedbackZipcode () {
      return this.stateZipcode === true ? 'สำเร็จ' : ''
    }
  },
  mounted () {
    console.log('Vue is mounted')
    this.updateCompany()
    this.getCompany()
  }
}
</script>

<style scoped>
@import '../css/EditProfile.css';
</style>
